#include "crossroads.h"

void error (char const *fmt, ...) {
    va_list args;
    char *str;

    va_start (args, fmt);
    str = str_vprintf (fmt, args);
    if (!daemonized)
	fprintf (stderr, "ERROR: %s\n", str);
    else
	writelog (LOG_ERR, "ERROR: %s", str);
    free (str);
    exit (1);
}
