#include "crossroads.h"

void http_header_removeheader (HttpHeader *h, char const *hdr) {
    int i;
    char *cp;

    for (i = 0; i < h->nheader; i++)
	if (h->header[i] && !strncasecmp (h->header[i], hdr, strlen(hdr))) {
	    cp = h->header[i] + strlen(hdr);
	    if (*cp == ':') {
		msg ("Service %s: removing header '%s'",
		     activeservice->name, hdr);
		free (h->header[i]);
		h->header[i] = 0;
	    }
	}
}
