#include "crossroads.h"

void http_header_write (HttpHeader *m, int sock, CopyDirection dir) {
    int i;

    msg ("Service %s: Sending HTTP headers to %s",
	 activeservice->name,
	 dir == dir_server_to_client ? "client" : "server");
    
    for (i = 0; i < m->nheader; i++) {
	if (! m->header[i] || ! *m->header[i])
	    continue;
	msg ("Service %s: sending header %d: '%s'",
	     activeservice->name, i, m->header[i]);
	http_write (sock, dir, (unsigned char const *) m->header[i],
		    strlen(m->header[i]));
	http_write (sock, dir, (unsigned char const *) "\r\n", 2);
    }
    http_write (sock, dir, (unsigned char const *) "\r\n", 2);
}
