#include "crossroads.h"

int http_write (int sock, CopyDirection dir, unsigned char const *buf,
		unsigned buflen) {
    int nwritten, totwritten = 0;

    while (totwritten < buflen) {
	nwritten = net_write (sock, buf + totwritten, buflen - totwritten,
			      dir == dir_client_to_server);
	totwritten += nwritten;
    }
    return (0);
}
