#ifndef HAVE_STRLCAT

#include "crossroads.h"

size_t strlcat (char *dst, char const *src, size_t size) {
    size_t bytes = 0;
    char *q = dst;
    char const *p = src;
    char ch;
    
    while ( bytes < size && *q ) {
	q++;
	bytes++;
    }
    while ( (ch = *p++) ) {
	if ( bytes < size )
	    *q++ = ch;
	bytes++;
    }
    *q = '\0';
    return bytes;
}  

#endif
