#include "crossroads.h"

void warning (char const *fmt, ...) {
    va_list args;
    char *str;

    va_start (args, fmt);
    str = str_vprintf (fmt, args);
    if (!daemonized)
	fprintf (stderr, "WARNING: %s\n", str);
    else
	writelog (LOG_ERR, "WARNING: %s", str);
    free (str);
}
