#include "crossroads.h"

char *xstrcat (char *what, char const *rest) {
    if (!what || !*what)
	return (xstrdup (rest));
    if (!rest || !*rest)
	return (what);
    
    if (! (what = realloc (what, strlen(what) + strlen(rest) + 1)) )
	error ("Out of memory (while adding '%s' to '%s'",
	       rest, what);
    strlcat (what, rest, strlen(what) + strlen(rest) + 1);
    return (what);
}
