#include "crossroads.h"

char *http_expand_header (char const *h) {
    char *ret = 0;
    char const *cp;

    for (cp = h; cp && *cp; cp++) {
	if (*cp == '%') {
	    switch (*(cp + 1)) {
	    case 'r':
		ret = xstrcat (ret, client_ip);
		cp++;
		break;
	    case 't':
		ret = xstrcat (ret, ansistamp (tm_localtime));
		cp++;
		break;
	    case 'T':
		ret = xstrcat (ret, ansistamp (tm_gmtime));
		cp++;
		break;
	    case 'v':
		ret = xstrcat (ret, VER);
		cp++;
		break;
	    default:
		if (*(cp + 1)) {
		    ret = xstrcatch (ret, *(cp + 1));
		    cp++;
		}
		break;
	    }
	} else {
	    ret = xstrcatch (ret, *cp);
	}
    }

    return (ret);
}
    
		
