#include "crossroads.h"

void msg (char const *fmt, ...) {
    va_list args;
    char *str;

    if (!flag_verbose)
	return;
    va_start (args, fmt);
    str = str_vprintf (fmt, args);
    if (!daemonized)
	fprintf (stderr, "INFO: %s\n", str);
    else
	writelog (LOG_NOTICE, "INFO: %s", str);

    va_end (args);
}
